Class | AMQP::RPC
In: | lib/amqp/deprecated/rpc.rb
Parent: | ::AMQP::BlankSlate

Basic RPC (remote procedure call) facility.

Needs more detail and explanation.

     EM.run do
       server = AMQP::Channel.new.rpc('hash table node', Hash)

       client = AMQP::Channel.new.rpc('hash table node')
       client[:now] = Time.now
       client[:one] = 1

       client.values do |res|
         p 'client', :values => res
       end

       client.keys do |res|
         p 'client', :keys => res
         EM.stop_event_loop
       end
     end

@note This class will be removed before 1.0 release. @deprecated @private

### Methods

client? method_missing new normalize server?

### Classes and Modules

Class AMQP::RPC::Client
Class AMQP::RPC::Server

### Attributes

name | [R] | API

### Public Class methods

new(channel, queue, obj = nil)

Takes a channel, queue and optional object.

The optional object may be a class name, module name or object instance. When given a class or module name, the object is instantiated during this setup. The passed queue is automatically subscribed to so it passes all messages (and their arguments) to the object.

Marshalling and unmarshalling the objects is handled internally. This marshalling is subject to the same restrictions as defined in the {ruby-doc.org/core/classes/Marshal.html Marshal} standard library. See that documentation for further reference.

When the optional object is not passed, the returned rpc reference is used to send messages and arguments to the queue. See method_missing which does all of the heavy lifting with the proxy. Some client elsewhere must call this method with the optional block so that there is a valid destination. Failure to do so will just enqueue marshalled messages that are never consumed.

### Public Instance methods

client?()
method_missing(selector, *args, &block)
server?()

### Protected Instance methods

normalize(input)

[Validate]